﻿using System;
using System.Web.Mvc;
using Kreta.BusinessLogic.Security;
using Kreta.Enums;
using Kreta.Resources;
using Kreta.Web.Areas.GRModul.Models;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.GRModul.Controllers
{
    [MvcRoleClaimsAuthorize(true)]
    [MvcRolePackageAuthorize(KretaClaimPackages.GazdasagiUgyintezo.ClaimValue)]
    public class UzletiTervezesController : Controller
    {

        public ActionResult Index()
        {
            ViewData[GRModulResource.IntezmenyAzonositoKey] = ClaimData.IntezmenyAzonosito;

            return View();
        }

        public ActionResult AlkalmazottTenyAdatok(string azonosito, string honap)
        {
            ViewData[GRModulResource.IntezmenyAzonositoKey] = ClaimData.IntezmenyAzonosito;

            if (Enum.TryParse(honap, out HonapokEnum selectedHonap))
            {
                var vm = new UzletiTervSearchModel
                {
                    SelectedRovatAzonosito = azonosito,
                    Honap = selectedHonap
                };

                return View(vm);
            }

            return View();
        }
    }
}
