﻿using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;
using Kreta.Web.Areas.Intezmeny.Models;
using Kreta.Web.Models.EditorTemplates;

namespace Kreta.Web.Areas.GRModul.Models
{
    public class BeszerzesiIgenyModel : PanelBarBaseModel
    {
        public int? BeszerzesiIgenyId { get; set; }

        public IntezmenyModel IntezmenyModel { get; set; }

        [ValidateObject]
        public IgenyAdatokModel IgenyAdatokModel { get; set; }

        [ValidateObject]
        public SzallitoModel SzallitoModel { get; set; }

        [ValidateObject]
        public MegjegyzesModel MegjegyzesModel { get; set; }

        public bool IsModosithato { get; set; }

        public bool IsVezeto { get; set; }

        public int? RogzitoId { get; set; }

        public static BeszerzesiIgenyCo ConvertModelToCo(BeszerzesiIgenyModel model)
        {
            return new BeszerzesiIgenyCo
            {
                BeszerzesiIgenyId = model.BeszerzesiIgenyId,
                RogzitoId = model.RogzitoId,
                //Anyag
                AnyagId = model.IgenyAdatokModel.AnyagId,
                AnyagMegnevezes = model.IgenyAdatokModel.AnyagMegnevezes,
                //AnyagSAPKod = model.IgenyAdatokModel.,
                //ERAAzonosito = model.IgenyAdatokModel.
                AnyagMennyisegiEgysegId = model.IgenyAdatokModel.AnyagMennyisegiEgysegId,
                AnyagRovidLeiras = model.IgenyAdatokModel.AnyagRovidLeiras,
                //Tétel
                AnyagTetelMegnevezes = model.IgenyAdatokModel.AnyagTetelMegnevezes,
                AnyagTetelEgysegar = model.IgenyAdatokModel.AnyagTetelEgysegar,
                AnyagTetelMennyiseg = model.IgenyAdatokModel.AnyagTetelMennyiseg,
                AnyagTetelMennyisegiEgysegId = model.IgenyAdatokModel.AnyagTetelMennyisegiEgysegId,
                //Pályázat
                //IsPalyazat = model.IgenyAdatokModel.IsPalyazat,
                PalyazatAzonosito = model.IgenyAdatokModel.AnyagTetelMegnevezes,
                IsBVOP = model.IgenyAdatokModel.IsBVOP,
                IsKEF = model.IgenyAdatokModel.IsKEF,
                IsNKOH = model.IgenyAdatokModel.IsNKOH,
                //Szállító
                SzallitoId = model.SzallitoModel?.SzallitoId,
                FizetesiMod = model.SzallitoModel?.FizetesiMod,
                //SzallitoSAPKod = model.SzallitoModel.,
                SzallitoNev = model.SzallitoModel?.SzallitoNev,
                Iranyitoszam = model.SzallitoModel?.IrSzam,
                HelysegNev = model.SzallitoModel?.HelysegNev,
                KozteruletNev = model.SzallitoModel?.KozteruletNev,
                KozteruletJellegeId = model.SzallitoModel?.KozteruletJellegId,
                Hazszam = model.SzallitoModel?.Hazszam,
                Emelet = model.SzallitoModel?.Emelet,
                Ajto = model.SzallitoModel?.Ajto,
                Adoszam = model.SzallitoModel?.Adoszam,
                KepviseloNev = model.SzallitoModel?.KepviseloNeve,
                EmailCim = model.SzallitoModel?.EmailCim,
                Telefonszam = model.SzallitoModel?.Telefonszam,
                //Megjegyzés
                Megjegyzes = model.MegjegyzesModel?.Megjegyzes
            };
        }
    }

    public class AnyagModel
    {
        [Display(Name = nameof(GRModulResource.AnyagSzamaEsMegnevezese), ResourceType = typeof(GRModulResource))]
        public int? AnyagId { get; set; }

        [Display(Name = nameof(GRModulResource.AnyagMegnevezese), ResourceType = typeof(GRModulResource))]
        public string AnyagMegnevezes { get; set; }

        [Display(Name = nameof(GRModulResource.MennyisegEgysege), ResourceType = typeof(GRModulResource))]
        public int? AnyagMennyisegiEgysegId { get; set; }

        [Display(Name = nameof(GRModulResource.AnyagRovidLeirasa), ResourceType = typeof(GRModulResource))]
        public string AnyagRovidLeiras { get; set; }

        [Display(Name = nameof(GRModulResource.TetelMegnevezése), ResourceType = typeof(GRModulResource))]
        public string AnyagTetelMegnevezes { get; set; }

        [Display(Name = nameof(GRModulResource.TetelEgysegara), ResourceType = typeof(GRModulResource))]
        public int? AnyagTetelEgysegar { get; set; }

        [Display(Name = nameof(GRModulResource.Mennyiseg), ResourceType = typeof(GRModulResource))]
        public int? AnyagTetelMennyiseg { get; set; }

        [Display(Name = nameof(GRModulResource.MennyisegEgysege), ResourceType = typeof(GRModulResource))]
        public int? AnyagTetelMennyisegiEgysegId { get; set; }
    }

    public class IgenyAdatokModel : AnyagModel
    {
        [Display(Name = nameof(GRModulResource.Palyazat), ResourceType = typeof(GRModulResource))]
        public int? IsPalyazat { get; set; }

        [Display(Name = nameof(GRModulResource.PalyazatAzonositoja), ResourceType = typeof(GRModulResource))]
        public string PalyazatAzonosito { get; set; }

        [Display(Name = nameof(GRModulResource.PalyazatBVOP), ResourceType = typeof(GRModulResource))]
        public bool IsBVOP { get; set; }

        [Display(Name = nameof(GRModulResource.PalyazatKEF), ResourceType = typeof(GRModulResource))]
        public bool IsKEF { get; set; }

        [Display(Name = nameof(GRModulResource.PalyazatNKOH), ResourceType = typeof(GRModulResource))]
        public bool IsNKOH { get; set; }
    }

    public class SzallitoModel
    {
        [Display(Name = nameof(GRModulResource.Szallito), ResourceType = typeof(GRModulResource))]
        public int? SzallitoId { get; set; }

        [Display(Name = nameof(GRModulResource.FizetesiMod), ResourceType = typeof(GRModulResource))]
        public int? FizetesiMod { get; set; }

        [Display(Name = nameof(GRModulResource.SzallitoNev), ResourceType = typeof(GRModulResource))]
        public string SzallitoNev { get; set; }

        [Display(Name = nameof(GRModulResource.IrSzam), ResourceType = typeof(GRModulResource))]
        public string IrSzam { get; set; }

        [Display(Name = nameof(GRModulResource.HelysegNev), ResourceType = typeof(GRModulResource))]
        public string HelysegNev { get; set; }

        [Display(Name = nameof(GRModulResource.KozteruletNev), ResourceType = typeof(GRModulResource))]
        public string KozteruletNev { get; set; }

        [Display(Name = nameof(GRModulResource.KozteruletJelleg), ResourceType = typeof(GRModulResource))]
        public int? KozteruletJellegId { get; set; }

        [Display(Name = nameof(GRModulResource.Hazszam), ResourceType = typeof(GRModulResource))]
        public string Hazszam { get; set; }

        [Display(Name = nameof(GRModulResource.Emelet), ResourceType = typeof(GRModulResource))]
        public string Emelet { get; set; }

        [Display(Name = nameof(GRModulResource.Ajto), ResourceType = typeof(GRModulResource))]
        public string Ajto { get; set; }

        [Display(Name = nameof(GRModulResource.KepviseloNeve), ResourceType = typeof(GRModulResource))]
        public string KepviseloNeve { get; set; }

        [Display(Name = nameof(GRModulResource.Adoszam), ResourceType = typeof(GRModulResource))]
        public string Adoszam { get; set; }

        [Display(Name = nameof(GRModulResource.Telefonszam), ResourceType = typeof(GRModulResource))]
        public string Telefonszam { get; set; }

        [Display(Name = nameof(GRModulResource.EmailCim), ResourceType = typeof(GRModulResource))]
        public string EmailCim { get; set; }
    }

    public class MegjegyzesModel
    {
        [Display(Name = nameof(GRModulResource.Megjegyzes), ResourceType = typeof(GRModulResource))]
        public string Megjegyzes { get; set; }
    }
}
