﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;

namespace Kreta.Web.Areas.GRModul.Models
{
    public class KotvallSearchModel
    {
        [Display(Name = nameof(CommonResource.Tanev), ResourceType = typeof(CommonResource))]
        public int? Tanev { get; set; }

        [Display(Name = nameof(KotvallKezelesResource.Sorszam), ResourceType = typeof(KotvallKezelesResource))]
        public string Sorszam { get; set; }

        [Display(Name = nameof(KotvallKezelesResource.BejelentoNeve), ResourceType = typeof(KotvallKezelesResource))]
        public Guid? BejelentoIdpEgyediAzonosito { get; set; }

        [Display(Name = nameof(KotvallKezelesResource.Statusz), ResourceType = typeof(KotvallKezelesResource))]
        public int? StatuszId { get; set; }

        [Display(Name = nameof(KotvallKezelesResource.BeszerzesTargya), ResourceType = typeof(KotvallKezelesResource))]
        public string BeszerzesTargya { get; set; }

        [Display(Name = nameof(KotvallKezelesResource.BruttoErtek), ResourceType = typeof(KotvallKezelesResource))]
        public int? BruttoErtekTol { get; set; }

        [Display(Name = nameof(KotvallKezelesResource.BruttoErtek), ResourceType = typeof(KotvallKezelesResource))]
        public int? BruttoErtekIg { get; set; }

        public KotvallSearchCo ConvertToCo()
        {
            return new KotvallSearchCo
            {
                BejelentoIdpEgyediAzonosito = BejelentoIdpEgyediAzonosito,
                BeszerzesTargya = BeszerzesTargya,
                BruttoErtekIg = BruttoErtekIg,
                BruttoErtekTol = BruttoErtekTol,
                Sorszam = Sorszam,
                StatuszId = StatuszId,
                TanevId = Tanev,
            };
        }
    }
}
